<?php

$fn = __DIR__ . '/../index.js'; // original JS
$js = '';		                // code to compress
$jscomp = '';	                // compressed JS
$reduced = -1;	                // compression saving

// Fetch JavaScript file
$js = file_get_contents($fn);

// REST API arguments
$args = 'js_code=' . urlencode($js);
foreach (file($fn) AS $line) {
    if (preg_match('|^//\s+@([a-z_]+)\s+(.*)$|', $line, $matches)) {
        if ($matches[1] != 'output_file_name') {
            $args .= '&' . $matches[1] . '=' . urlencode($matches[2]);
        }
    }
}

// API call using cURL
$call = curl_init();
curl_setopt_array(
    $call,
    array(
        CURLOPT_URL => 'http://closure-compiler.appspot.com/compile',
        CURLOPT_POST => 1,
        CURLOPT_POSTFIELDS => $args,
        CURLOPT_RETURNTRANSFER => 1,
        CURLOPT_HEADER => 0,
        CURLOPT_FOLLOWLOCATION => 0
    )
);
$jscomp = curl_exec($call);
curl_close($call);

// Post-process
$jscomp = str_replace("\r",                     '', $jscomp);
$jscomp = str_replace("\n",                     '', $jscomp);
$jscomp = str_replace('updatestats();',         '', $jscomp);
$jscomp = str_replace(',updatestats()',         '', $jscomp);
$jscomp = str_replace('window.init=init;',      '', $jscomp);
$jscomp = str_replace('window.init=function()', 'function init()', $jscomp);
    // vars
$jscomp = str_replace('text_canvas',            'x', $jscomp);
$jscomp = str_replace('glsl_canvas',            'y', $jscomp);
$jscomp = str_replace('main_canvas',            'b', $jscomp);
$jscomp = str_replace('gl_canvas',              'c', $jscomp);
$jscomp = str_replace('scene',                  's', $jscomp);
$jscomp = str_replace('group',                  't', $jscomp);
$jscomp = str_replace('camera',                 'u', $jscomp);
$jscomp = str_replace('glsl_alpha',             'v', $jscomp);
$jscomp = str_replace('glsl',                   'w', $jscomp);
$jscomp = str_replace('text',                   'e', $jscomp);
$jscomp = str_replace('iteration',              'f', $jscomp);
$jscomp = str_replace('first',                  'g', $jscomp);
$jscomp = str_replace('intro_pos',              'h', $jscomp);
    // funcs
$jscomp = str_replace('arrayAdd',               'z', $jscomp);
$jscomp = str_replace('buildScene',             'l', $jscomp);
$jscomp = str_replace('initIntro',              'm', $jscomp);
$jscomp = str_replace('animIntro',              'n', $jscomp);
$jscomp = str_replace('hilbert3D',              'o', $jscomp);
$jscomp = str_replace('initMain',               'p', $jscomp);
$jscomp = str_replace('animMain',               'q', $jscomp);
    // Three.js
$jscomp = str_replace('THREE.',                 'T.', $jscomp);

// Save compressed content
file_put_contents(__DIR__ . '/../index.min.js', $jscomp);

// Calculate compression saving
$reduced = (strlen($js) - strlen($jscomp)) / strlen($js) * 100;
// Output saving
if ($reduced >= 0) {
	echo
        'Original file : ' . strlen($js) . ' bytes' . PHP_EOL .
        'Compressed file : ' . strlen($jscomp) . ' bytes' . PHP_EOL .
        'Ratio : ', round($reduced, 1), '%.' . PHP_EOL;
}

?>